=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20191014-2) unstable; urgency=medium

  * Do not use the packaged FindSDL2 package. Closes: #951976
    - New patch 100-fix-sdl2-detection.patch
    - B-D on libsdl-dev (>= 2.0.4) to mitigate #951087.
    Many thanks Simon McVittie for hinting into the right direction.

 -- Tobias Frost <tobi@debian.org>  Sun, 23 Feb 2020 17:21:40 +0100

rbdoom3bfg (1.2.0+dfsg~git20191014-1) unstable; urgency=medium

  * New upstream release, upstream versioned it as 1.2.0-preview1.
  * Refresh patches as needed to remove fuzz.
  * New patch 90-fix-include-path to fix FTBFS with new upstream source.
  * Fix new typo found by lintian in the spelling error patch.
  * Delete 30-init-sdl2.patch, unapplied since a few versions.
  * Drop 70-disable-hdr-by-default.patch, underlaying issue has been
    fixed upstream.
  * Bump S-V to 4.4.1 -- no changes required except specifying
    rules-requires-root=no.
  * Drop d/compat in favour of debhelper-compat (=12) as B-D.

 -- Tobias Frost <tobi@debian.org>  Tue, 15 Oct 2019 20:30:51 +0200
