=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CMAKE_ADDTIONAL_FLAGS ?=
ifeq ($(findstring $(DEB_BUILD_ARCH), amd64 kfreebsd-amd64),)
CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
endif

%:
	dh $@ --sourcedirectory=neo

override_dh_auto_configure:
	dh_auto_configure -- -G "Unix Makefiles" \
	 -DSDL2=ON -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	 -DUSE_SYSTEM_ZLIB=ON -DUSE_SYSTEM_LIBPNG=ON \
	 -DUSE_SYSTEM_LIBJPEG=ON -DUSE_SYSTEM_LIBGLEW=ON \
         -DUSE_SYSTEM_RAPIDJSON=ON \
	 -DCPU_TYPE=$(DEB_BUILD_ARCH_CPU) \
	 -DUSE_PRECOMPILED_HEADERS=OFF \
	 -DCPU_OPTIMIZATION="" \
	 $(CMAKE_ADDITIONAL_FLAGS)

override_dh_installchangelogs:
	# We won't have a ChangeLog if packaging from a released tarball.
	# In this case, use the RELEASE-NOTES.txt
	dh_installchangelogs
	if [ ! -e ChangeLog ]; then \
	dh_installchangelogs -k RELEASE-NOTES.txt ; \
	fi
