=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20200817-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Refresh 10-lowercase-executable.patch
  * Add patch to fix FTBFS with relative include path.
  * lintian-overides: Use wildcard to stop complains about spelling errors.

 -- Tobias Frost <tobi@debian.org>  Tue, 25 Aug 2020 15:54:05 +0200

rbdoom3bfg (1.2.0+dfsg~git20200619-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Drop patches 40-libpng16.patch and 50-fix-imgui-includepath.patch;
      they have been applied upstream.
    - Refresh patch 10-lowercase-executable.patch.
  * Make (pedantic) lintian a bit happier
    - s/VCS/Vcs in d/control.
    - remove --as-needed from linker flags in d/rules.
    - ignore one more spelling error.
  * Use debhelper compat level 13.
  * Fix "rbdoom3bfg FTCBFS: confuses build and host", thanks to Helmut for
    the patch. (Closes: #962428)

 -- Tobias Frost <tobi@debian.org>  Sun, 05 Jul 2020 19:45:53 +0200

rbdoom3bfg (1.2.0+dfsg~git20200327-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Updating patches:
      - Refresh 10-lowercase-executable.patch.
      - Remove 20-reproducible.patch, should no longer be needed.
      - Refresh 40-libpng16.patch.
      - Remove 60-spelling-errors.patch, upstream will never accept it and it
        starts to become a burden.
      - Remove 90-fix-include-path.patch, applied upstream.
      - Remove 100-fix-sdl2-detection.patch, applied upstream.
      - New patch 50-fix-imgui-includepath.patch, otherwise it will fail to
        compile.
  * Upstream moved around some docs, adapting d/docs, d/install and d/rules
    accordingly.
  * Update SV, no changes.

 -- Tobias Frost <tobi@debian.org>  Tue, 31 Mar 2020 11:27:50 +0200
