=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Tobias Frost <tobi@debian.org>
 Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libavcodec-dev,
                libavformat-dev,
                libavutil-dev,
@@ -16,11 +16,11 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
-VCS-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
-VCS-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git
+Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
+Vcs-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git
 
 Package: rbdoom3bfg
 Architecture: any
