## rbdoom3bfg 1.2.0+dfsg~git20210105

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,11 @@
 	set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
 endif()
 
-option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "((powerpc|ppc)64le)|(mips64)")
+	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" OFF)
+else()
+	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+endif()
 
 if(FFMPEG AND BINKDEC)
 	message(FATAL_ERROR "Only one of FFMPEG and BINKDEC (or neither) can be enabled at a time")
@@ -247,8 +251,8 @@
 					-D_CRT_SECURE_NO_DEPRECATE
 					-D_CRT_NONSTDC_NO_DEPRECATE
 					-D_CRT_SECURE_NO_WARNINGS
-                                        -D_MBCS
-                                       #-DUSE_OPENAL
+					-D_MBCS
+					#-DUSE_OPENAL
 					-DUSE_EXCEPTIONS)
         ## Check for Version ##
         if( WINRT OR WINDOWS10 ) # Windows RT
@@ -321,33 +325,9 @@
 endmacro()
 
 if(USE_VULKAN)
-	# Use FindVulkan module added with CMAKE 3.7
-	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
-		message( STATUS "Using module to find Vulkan" )
-		find_package(Vulkan)
-	endif()
-
-	if(NOT Vulkan_FOUND)
-		message(FATAL_ERROR "Could not find Vulkan library!")
-	else()
-		message(STATUS ${Vulkan_LIBRARY})
-	endif()
-	
-	add_definitions(-DUSE_VULKAN)
-	include_directories($ENV{VULKAN_SDK}/include)
-
-	# Eric: For use with SDL2/Vulkan
-	if(UNIX)
-		find_package(X11_XCB)
-		if(X11_XCB_FOUND)
-			add_definitions(-DHAVE_X11_XCB)
-			list(APPEND SUBSYSTEMS [X11])
-			include_directories(${X11_XCB_INCLUDE_DIRS})
-		endif()
-		add_definitions(-DVK_USE_PLATFORM_XLIB_KHR)
-	elseif(WIN32)
-		add_definitions(-DVK_USE_PLATFORM_WIN32_KHR)
-	endif()
+
+	# RB: moved this above the general Vulkan part so glslang does not include Vulkan SDK headers
+	# which causes all kinds of weird segmentation faults because struct sizes don't match
 
 	if(SPIRV_SHADERC)
 		add_definitions(-DSPIRV_SHADERC)
@@ -362,19 +342,38 @@
 		# override Glslang build options
 		
 		# options required by November 2018 release
-		SET_OPTION(ENABLE_SPVREMAPPER OFF)
+		SET_OPTION(ENABLE_SPVREMAPPER ON)
 		SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
 		SET_OPTION(ENABLE_HLSL OFF)
 		SET_OPTION(ENABLE_OPT ON)
 		SET_OPTION(SPIRV_SKIP_EXECUTABLES ON)
 		
-		# options required by November 2019 release
-		#SET_OPTION(ENABLE_PCH OFF)
-		#SET_OPTION(ENABLE_CTEST OFF)
-		#SET_OPTION(BUILD_EXTERNAL OFF)
-		#SET_OPTION(SKIP_GLSLANG_INSTALL ON)
+		# options required by July 2020 release
+		SET_OPTION(ENABLE_PCH OFF)
+		SET_OPTION(ENABLE_CTEST OFF)
+		SET_OPTION(BUILD_EXTERNAL OFF)
+		SET_OPTION(SKIP_GLSLANG_INSTALL ON)
+
+		#add_definitions(-DGLSLANG_MINOR_VERSION=13)
 	
 		set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extern/glslang)
 		add_subdirectory(${GLSLANG_DIR})
 	
 		include_directories(${GLSLANG_DIR}/glslang)
+		
+		#link_directories($ENV{VULKAN_SDK}/Lib)
+	endif()
+
+	# Use FindVulkan module added with CMAKE 3.7
+	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
+		message( STATUS "Using module to find Vulkan" )
+		find_package(Vulkan)
+	endif()
+
+	if(NOT Vulkan_FOUND)
+		message(FATAL_ERROR "Could not find Vulkan library!")
+	else()
+		message(STATUS ${Vulkan_LIBRARY})
+	endif()
+	
+	add_definitions(-DUSE_VULKAN)
