=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20210105-1) unstable; urgency=low

  [ Tobias Frost ]
  * Disable repotest on salsa-CI.
  * New upstream git snapshot.
  * Refresh debian/patches/10-lowercase-executable.patch
  * Remove 20-fix-imgui-include.patch, applied upstream.
  * Add lintian override license-problem-json-evil, it is only quoted in a
    in a document but the library has been removed with the dfsg repacking.
  * Bump S-V to 4.5.1, no changes.
  * Update d/copyright years.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Tobias Frost <tobi@debian.org>  Wed, 03 Feb 2021 17:58:24 +0100
