=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
 Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
