=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
 # output every command that modifies files on the build system.
@@ -7,12 +8,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-
-DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 CMAKE_ADDTIONAL_FLAGS ?=
-ifeq ($(findstring $(DEB_BUILD_ARCH), amd64 kfreebsd-amd64),)
+ifneq ($(DEB_HOST_ARCH_CPU),amd64)
 CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
 endif
 
@@ -32,8 +30,8 @@
 
 override_dh_installchangelogs:
 	# We won't have a ChangeLog if packaging from a released tarball.
-	# In this case, use the RELEASE-NOTES.txt
+	# In this case, use the RELEASE-NOTES.md
 	dh_installchangelogs
 	if [ ! -e ChangeLog ]; then \
-	dh_installchangelogs -k RELEASE-NOTES.txt ; \
+	dh_installchangelogs -k RELEASE-NOTES.md ; \
 	fi
