=== debian/changelog ===
rbdoom3bfg (1.3.0+dfsg-2) unstable; urgency=medium

  * Fix build on i386: Upstream renamed the cmake option to disable
    CPU optimizations which are above the i386 baseline in Debian.

 -- Tobias Frost <tobi@debian.org>  Mon, 24 Jan 2022 14:16:26 +0100

rbdoom3bfg (1.3.0+dfsg-1) unstable; urgency=medium

  * Retire d/README.source, the information within was outdated
    regarding getting the source: Noweedays a simple uscan will cut it.
  * Update watch file to track the release upstream has made we are
    preparing.
  * Refresh patch 10-lowercase-executable.patch.
  * Review/Update d/copyright.
  * Update lintian overrides.
  * Update S-V to 4.6.0 -- no changes required.
  * Update d/upstream/metadata.

 -- Tobias Frost <tobi@debian.org>  Mon, 24 Jan 2022 13:29:10 +0100
