=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,10 @@
 #DH_VERBOSE = 1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 
 CMAKE_ADDTIONAL_FLAGS ?=
 ifneq ($(DEB_HOST_ARCH_CPU),amd64)
-CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
+CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS_SSE=OFF
 endif
 
 %:
