=== debian/watch ===
version=4

# tracking upstream releases
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%, dversionmangle=s/\+dfsg\d*$//" \
   https://github.com/RobertBeckebans/RBDOOM-3-BFG/releases \
   (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

# tracking upstream commit based watch file (retained for the future tobi)
#opts="mode=git, pgpmode=none, pretty=1.2.0+dfsg~git%cd, dversionmangle=s/\+dfsg\d*$//" \
#https://github.com/RobertBeckebans/RBDOOM-3-BFG.git \
#HEAD debian uupdate
