## rbdoom3bfg 1.4.0%2Bdfsg

=== debian/changelog ===
rbdoom3bfg (1.4.0+dfsg-7ubuntu2) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Sep 2025 09:49:51 +0200

rbdoom3bfg (1.4.0+dfsg-7ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3
    - Comment out for now imgui build fix until new version reaches Ubuntu

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Sep 2025 09:31:55 +0200

rbdoom3bfg (1.4.0+dfsg-7) unstable; urgency=medium

  * Fix build against ffmpeg 8.0 (Closes: #1115040)

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 13 Sep 2025 10:26:16 +0200

rbdoom3bfg (1.4.0+dfsg-6ubuntu2) questing; urgency=medium

  * Comment out for now imgui build fix, we still have the old version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Sep 2025 14:32:22 +0200

rbdoom3bfg (1.4.0+dfsg-6ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Sep 2025 10:32:54 +0200

rbdoom3bfg (1.4.0+dfsg-6) unstable; urgency=medium

  * Fix build with CMake 4 (Closes: #1113459)
  * Fix build against libimgui-dev 1.92.2

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 01 Sep 2025 08:02:43 +0200

rbdoom3bfg (1.4.0+dfsg-5ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Mar 2025 14:28:03 +0100

rbdoom3bfg (1.4.0+dfsg-5) unstable; urgency=medium

  * d/rbdoom3bfg.desktop: use game-data-packager's launcher
  * d/control: recommends game-data-packager-runtime
  * update S-V to 4.7.2 -- no changes required.

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 12 Mar 2025 14:13:55 +0100

rbdoom3bfg (1.4.0+dfsg-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 09 Nov 2024 20:27:16 +0100

rbdoom3bfg (1.4.0+dfsg-4) unstable; urgency=medium

  * Adopt package and set Maintainer to Debian Games Team (Closes: #1035299)
  * Install a desktop file in /usr/share/applications
  * Add d/p/spelling.patch to correct spelling errors spotted by Lintian

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 06 Nov 2024 13:59:36 +0100

rbdoom3bfg (1.4.0+dfsg-3ubuntu1) oracular; urgency=medium

  * Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 20:14:06 +0200

rbdoom3bfg (1.4.0+dfsg-3) unstable; urgency=medium

  * Set Maintainer to the QA Group.
  * Fix building with ffmpeg 7.0 (Closes: #1072448)
  * Set minimum version of rapidjson due to #1074897.

 -- Tobias Frost <tobi@debian.org>  Mon, 29 Jul 2024 10:28:10 +0200

rbdoom3bfg (1.4.0+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Avoid including ../../imgui/imgui.h. (Closes: #1028279)

  [ Tobias Frost ]
  * Update copyright years.
  * Bump to SV 4.6.2 -- no changed.

 -- Tobias Frost <tobi@debian.org>  Thu, 19 Jan 2023 15:33:57 +0100

rbdoom3bfg (1.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Remove bundled imgui and use Debian packaged one instead.
    - Refresh patch.
    - It is compatible with ffmpeg 5.0. (Closes: #1004574)
  * Update/Review d/copyright.
  * New patch to utilize packaged imgui.
  * d/control: Remove no longer needed versions from constraints.

 -- Tobias Frost <tobi@debian.org>  Mon, 28 Mar 2022 11:15:37 +0200
